## wildfly:add-resource

Full name:

org.wildfly.plugins:wildfly-maven-plugin:5.0.1.Final:add-resource

Description:

Adds a resource

If `force` is set to `false` and the resource has already been added to the server, an error will occur and the operation will fail.

Attributes:

- Requires a Maven project to be executed.
- The goal is thread-safe and supports parallel builds.

### Optional Parameters

Name | Type | Since | Description
--- | --- | --- | ---
`<address>` | `String` | `-` | The operation address, as a comma separated string. If the resource or resources also define and address, this address will be used as the parent address. Meaning the resource addresses will be prepended with this address.
`<authenticationConfig>` | `URL` | `-` | A URL which points to the authentication configuration (`wildfly-config.xml`) the client uses to authenticate with the server. User Property: `wildfly.authConfig` Alias: `authentication-config`
`<force>` | `boolean` | `-` | Specifies whether force mode should be used or not. If force mode is disabled, the add-resource goal will cause a build failure if the resource is already present on the server. Default: `true` User Property: `add-resource.force`
`<hostname>` | `String` | `-` | Specifies the host name of the server where the deployment plan should be executed. Default: `localhost` User Property: `wildfly.hostname`
`<id>` | `String` | `-` | Specifies the id of the server if the username and password is to be retrieved from the settings.xml file User Property: `wildfly.id`
`<jbossHome>` | `String` | `-` | The WildFly Application Server's home directory. This is not required, but should be used for commands such as `module add` as they are executed on the local file system. User Property: `jboss-as.home` Alias: `jboss-home`
`<password>` | `String` | `-` | Specifies the password to use if prompted to authenticate by the server. If no password is specified and the server requests authentication the user will be prompted to supply the password, User Property: `wildfly.password`
`<port>` | `int` | `-` | Specifies the port number the server is listening on. Default: `9990` User Property: `wildfly.port`
`<profiles>` | `List<String>` | `-` | The profiles where resources should be added to. User Property: `wildfly.profiles`
`<protocol>` | `String` | `-` | The protocol used to connect to the server for management. User Property: `wildfly.protocol`
`<resources>` | `Resource[]` | `-` | A collection of resources to add.
`<skip>` | `boolean` | `-` | Set to `true` if you want this goal to be skipped, otherwise `false`. Default: `false` User Property: `wildfly.skip`
`<timeout>` | `int` | `-` | The timeout, in seconds, to wait for a management connection. Default: `60` User Property: `wildfly.timeout`
`<username>` | `String` | `-` | Specifies the username to use if prompted to authenticate by the server. If no username is specified and the server requests authentication the user will be prompted to supply the username, User Property: `wildfly.username`

### Parameter Details

#### <address>

The operation address, as a comma separated string.

If the resource or resources also define and address, this address will be used as the parent address. Meaning the resource addresses will be prepended with this address.

- Type: `java.lang.String`
- Required: `No`

#### <authenticationConfig>

A URL which points to the authentication configuration (`wildfly-config.xml`) the client uses to authenticate with the server.

- Type: `java.net.URL`
- Required: `No`
- User Property: `wildfly.authConfig`
- Alias: `authentication-config`

#### <force>

Specifies whether force mode should be used or not.

If force mode is disabled, the add-resource goal will cause a build failure if the resource is already present on the server.

- Type: `boolean`
- Required: `No`
- User Property: `add-resource.force`
- Default: `true`

#### <hostname>

Specifies the host name of the server where the deployment plan should be executed.

- Type: `java.lang.String`
- Required: `No`
- User Property: `wildfly.hostname`
- Default: `localhost`

#### <id>

Specifies the id of the server if the username and password is to be retrieved from the settings.xml file

- Type: `java.lang.String`
- Required: `No`
- User Property: `wildfly.id`

#### <jbossHome>

The WildFly Application Server's home directory. This is not required, but should be used for commands such as `module add` as they are executed on the local file system.

- Type: `java.lang.String`
- Required: `No`
- User Property: `jboss-as.home`
- Alias: `jboss-home`

#### <password>

Specifies the password to use if prompted to authenticate by the server.

If no password is specified and the server requests authentication the user will be prompted to supply the password,

- Type: `java.lang.String`
- Required: `No`
- User Property: `wildfly.password`

#### <port>

Specifies the port number the server is listening on.

- Type: `int`
- Required: `No`
- User Property: `wildfly.port`
- Default: `9990`

#### <profiles>

The profiles where resources should be added to.

- Type: `java.util.List<java.lang.String>`
- Required: `No`
- User Property: `wildfly.profiles`

#### <protocol>

The protocol used to connect to the server for management.

- Type: `java.lang.String`
- Required: `No`
- User Property: `wildfly.protocol`

#### <resources>

A collection of resources to add.

- Type: `org.wildfly.plugin.deployment.resource.Resource[]`
- Required: `No`

#### <skip>

Set to `true` if you want this goal to be skipped, otherwise `false`.

- Type: `boolean`
- Required: `No`
- User Property: `wildfly.skip`
- Default: `false`

#### <timeout>

The timeout, in seconds, to wait for a management connection.

- Type: `int`
- Required: `No`
- User Property: `wildfly.timeout`
- Default: `60`

#### <username>

Specifies the username to use if prompted to authenticate by the server.

If no username is specified and the server requests authentication the user will be prompted to supply the username,

- Type: `java.lang.String`
- Required: `No`
- User Property: `wildfly.username`